##############################################################################
#
# verArbol 0.4: a simple tree visualizer
# Copyright (C) 2003 Juan Miguel Vilar
#                    Universitat Jaume I, Castell (Spain)
#
# This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
#  Any questions regarding this software should be directed to:
#
#   Juan Miguel Vilar
#   Departament de Llenguatges i Sistemes Informtics
#   Universitat Jaume I
#   E12071 Castelln (SPAIN)
#
#   email: jvilar@lsi.uji.es
#
##############################################################################
#
# Fichero: vAnalizador.mc
#
# Fecha: 25 de mayo de 2003
#
# Analizador de verArbol.py
#

cadena	trataCadena	"([^"\n]|"")*"
None	None		[ \t\n]+
corchete None		\]

%

def trataCadena (cad):
  cad.cad= string.replace(cad.lexema[1:-1], '""', '"')

def error_lexico(linea, cadena):
  if len(cadena)==1:
    error("Carcter %s inesperado en lnea %d." % (repr(cadena), linea))
  else:
    error("Caracteres %s inesperados en lnea %d." % (repr(cadena), linea))

class vAExcepcion(Exception):
  def __init__(self, mensaje):
    self.mensaje= mensaje

  def __str__(self):
    return self.mensaje

def error(mensaje):
  raise vAExcepcion(mensaje)

%

<Entrada> -> @Arbol.nivel= 0@
             <Arbol> @self.arboles=[Arbol.arbol]@
             ( @Arbol2.nivel=0@
               <Arbol> @self.arboles.append(Arbol2.arbol)@)* ;

<Arbol> -> "(" cadena @Arbol.arbol=[cadena.cad]@
              (cadena @Arbol.arbol.append(cadena2.cad)@)*
              ( @Arbol1.nivel= Arbol.nivel+1@
                <Arbol> @Arbol.arbol.append(Arbol1.arbol)@ )*
           ")" ;

<Arbol> -> error
            @if mc_al.actual.cat=="corchete":             @
            @  if Arbol.nivel:                            @
            @    return                                   @
            @  else:                                      @
            @    mc_al.sincroniza(mc_primeros["<Arbol>"]+["mc_EOF"]) @
	    @else:                                        @
            @  error("Error sintctico en lnea %d\n" % mc_al.actual.nlinea)@
           ;
